#include <stdio.h>
#include <stdlib.h>
#define MAX_N 10001

typedef struct _list_ {
  int k;
  struct _list_ *next;
} list;

int n;            /* The number of nodes */
int root;         /* The root where numbering starts */
list *e[MAX_N];   /* The tree is memorized as adjacency lists for every node */
int far d[MAX_N]; /* Degree of each node, indicating if it is on the chain */
int label[MAX_N]; /* What we actually need: the labels */

/* Add an edge from x to y */
void add(int x, int y)
{
  list *l=(list *)malloc(sizeof(list));
  l->k=y; l->next=e[x];
  e[x]=l;
  d[x]++;
}

/* Parse the input data */
void readData(void)
{
  FILE *f=fopen("cp.in", "rt");
  int i, x, y;

  /* Initialize the data structures */
  fscanf(f, "%d", &n);
  for (i=1; i<=n; i++)
    {
      d[i]=label[i]=0;
      e[i]=NULL;
    }

  /* Parse the edges and build d[] and e[] */
  for (i=1; i<n; i++)
    {
      fscanf(f, "%d %d", &x, &y);
      add(x, y); add(y,x);
    }
  fclose(f);
}

/* Find a root where numbering may start. That is, one of the chain's ends */
int findRoot(void)
{
  int i, count;
  list *l;

  if (n<3) return 1;
  for (i=1; i<=n; i++)
    if (d[i]>1)
      {
              count=0;
              for (l=e[i]; l; l=l->next)
                if (d[l->k]>1) count++;
              if (count<=1) return i;
      }
  return 0; /* Just to get rid of the warning */
}

/* Actually label the caterpillar */
void putLabels(void)
{
  int curNode=root, nextNode;
  int lo=1, stepLo=1, hi=n, stepHi=-1, temp;
  list *l;

  while (curNode)
    {
      nextNode=0; l=e[curNode];
      label[curNode]=lo; lo+=stepLo;
      while (l)
        {
          if (d[l->k]==1)
            {
              label[l->k]=hi;
              hi+=stepHi;
            }
          else if (!label[l->k])
            nextNode=l->k;
          l=l->next;
        }
      temp=lo; lo=hi; hi=temp;
      temp=stepLo; stepLo=stepHi; stepHi=temp;
      curNode=nextNode;
    }
}

void writeSolution(void)
{
  FILE *f=fopen("cp.out", "wt");
  int i;

  for (i=1; i<=n; i++)
    fprintf(f, "%d ", label[i]);
  fclose(f);
}

int main(void)
{
  readData();
  root=findRoot();
  putLabels();
  writeSolution();
  return 0; /* hopefully */
}
