program light;
const nbmax=200;
      nvmax=200;
      inFileName='light.in';
      outFileName='light.out';
type point=record
        x, y:longint;
     end;
     line=record
        a,b,c:longint;
     end;

     vectori=array[1..nvmax] of byte;
     matrixi=array[1..nbmax] of ^vectori;
     vectorr=array[1..nvmax] of real;
     matrixr=array[1..nbmax] of ^vectorr;


var  nv, nb, hb: longint;
     v:array[1..nvmax] of point;
     b:array[1..nbmax] of point;
     coresp:array[1..nbmax] of integer;
     vbv:matrixi;
     vbs:matrixr;

procedure init;
var i, j, k:integer;
    f:text;
begin
  assign(f, inFileName); reset(f);
  read(f, nv);
  for i:=1 to nv do read(f, v[i].x, v[i].y);
  read(f, nb, hb);
  for i:=1 to nb do begin
    read(f, b[i].x); b[i].y:=hb;
    new(vbv[i]);
    new(vbs[i]);
  end;
  close(f);
  i:=1; j:=1;
  while (i<=nb) and (j<=nv) do begin
    if b[i].x<=v[j].x then begin
      coresp[i]:=j; inc(i);
    end else inc(j);
  end;
  for i:=i to nb do begin
    coresp[i]:=nv;
  end;
end;

procedure dreapta(var a, b:point; var d:line);
begin
  d.a:=b.y-a.y;
  d.b:=a.x-b.x;
  d.c:=a.x*(a.y-b.y)-a.y*(a.x-b.x);
end;

function intersectie(var d:line; var a, b:point):real;
var temp:line;
begin
  dreapta(a, b, temp);
  intersectie:=
    (d.b*temp.c/temp.b - d.c)/(d.a - d.b*temp.a/temp.b);
end;

function  compare(var d1, d2: line):longint;
var t:longint;
begin
  t:=-d1.a*d2.b+d2.a*d1.b;
  if d1.b*d2.b>0 then
    compare:=t
  else
    compare:=-t;
end;

function value(var d:line; var p:point):longint;
begin
  value:=d.a*p.x+d.b*p.y+d.c;
end;



procedure precalcul;
var i, j:integer;
    min, temp:line;
begin
  for i:=1 to nb do begin
    vbv[i]^[coresp[i]]:=1;
    if coresp[i]>1 then vbs[i]^[coresp[i]-1]:=0;
    j:=coresp[i];
    if v[j].x>b[i].x then dec(j);
    if j>0 then begin
      vbv[i]^[j]:=1;
      dreapta(b[i], v[j], min);
      for j:=j-1 downto 1 do begin
        if value(min, v[j]) > 0 then begin
          vbv[i]^[j]:=1;
          if vbv[i]^[j+1]=1 then
            vbs[i]^[j]:=0
          else begin
            vbs[i]^[j]:=intersectie(min, v[j], v[j+1]);
          end;
          dreapta(b[i], v[j], min);
        end else begin
          vbv[i]^[j]:=0;
          vbs[i]^[j]:=-1;
        end;
      end;
    end;
    j:=coresp[i];
    if j<nv then begin
      dreapta(b[i], v[j], min);
      for j:=j+1 to nv do begin
        if value(min, v[j]) < 0 then begin
          vbv[i]^[j]:=1;
          if vbv[i]^[j-1]=1 then
            vbs[i]^[j-1]:=0
          else begin
            vbs[i]^[j-1]:=intersectie(min, v[j], v[j-1]);
          end;
          dreapta(b[i], v[j], min);
        end else begin
          vbv[i]^[j]:=0;
          vbs[i]^[j-1]:=-1;
        end;
      end;
    end;
  end;
end;

function verifica(var vect:vectorr; bec, position:integer):boolean;
var i:integer;
begin
  if bec>nb then begin
    verifica:=false;
    exit;
  end;
  verifica:=true;
  for i:=position to coresp[bec]-1 do begin
    if (vect[i]=0) or (vbs[bec]^[i]=0) or
       ((vect[i]>0) and (vbs[bec]^[i]>0)
        and (vect[i]<vbs[bec]^[i]))
    then
    else
      verifica:=false;
  end;
end;

procedure mark(var vect:vectorr; bec, position:integer);
var i:integer;temp:real;
begin

  for i:=position to nv-1 do begin
    temp:=vbs[bec]^[i];
    if temp>=0 then begin
      if (vect[i]<0)or(vbs[bec]^[i]=0) or (i>=coresp[bec])
      then vect[i]:=vbs[bec]^[i]
      else if (vect[i]>0) and (vbs[bec]^[i]>0) then
      vect[i]:=0;
    end;
  end;
end;

function stillneeded(var vect:vectorr):boolean;
var i:integer;
begin
  stillneeded:=false;
  for i:=nv-1 downto 1 do begin
    if vect[i]<>0 then begin
      stillneeded:=true;
      i:=1;
    end

  end;
end;

procedure  solve;
var v:vectorr;sol:vectori;
    i, j, k:integer;
    f:text;
begin
  for i:=1 to nv do v[i]:=-1;
  k:=0;
  i:=1;j:=0;
  while stillneeded(v) and (i<=nb) do begin
    k:=-1;
    while (i<=nb) and verifica(v, i, 1) do
    begin
      k:=i;
      inc(i);
    end;
    inc(j);
    if k=-1 then break;
    sol[j]:=k;
    mark(v, k, 1);
  end;
  assign(f, outFileName);rewrite(f);
  if (k=-1)or(stillneeded(v)) then begin
    write(f, 'NO SOLUTION');
  end else begin
    writeln(f, j);
    for i:=1 to j do write(f, sol[i], ' ');
  end;
  close(f);
end;

begin
  init;
  precalcul;
  solve;
end.