/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

/* Time Complexity: O(N*L*(L_W+L_B)) */

/* Score: 100 points */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pearls_lib.h"
#define filein "pearls.in"
#define maxl 1010
#define maxn 1010
#define maxlist 21

char win[maxl][maxn],necklace[maxl],ch;
long tip[maxn],list[maxn][2][maxlist],nel[maxn][2];
long l,n,start;

void readdata(void);
void compute(void);
void play(void);

int main()
{
readdata();
compute();
play();
return 0;
}

void readdata(void)
{
long i,j,k;

freopen(filein,"r",stdin);

scanf("%ld %ld %ld",&l,&n,&start);

/* read the necklace description */
for (i=1;i<=l;i++)
  {
  do
    {
    scanf("%c",&ch);
    }
  while (ch!='B' && ch!='W' && ch!='D');

  necklace[i]=ch;
  }

/* read the description of the dwarves */
for (i=1;i<=n;i++)
  {
  scanf("%ld",&tip[i]);

  /* read the black list */
  scanf("%ld",&nel[i][0]);
  for (j=1;j<=nel[i][0];j++)
    {
    scanf("%ld",&k);
    list[i][0][j]=k;
    }
    
  /* read the white list */
  scanf("%ld",&nel[i][1]);
  for (j=1;j<=nel[i][1];j++)
    {
    scanf("%ld",&k);
    list[i][1][j]=k;
    }
  }
}

void compute(void)
{
long i,j,k,p;

/* init the 'win' matrix */
for (i=1;i<=n;i++)
  win[l][i]=1;

for (p=l-1;p>=1;p--)
  for (i=1;i<=n;i++)
    {
    /*
       compute win[p][i] = does the team of dwarf #i win the game if
                           dwarf #i has the necklace during round #p ?
    */

    win[p][i]=0;

    if (necklace[p]=='B')
      {
      /* use the black list */
      for (j=1;j<=nel[i][0];j++)
        {
        k=list[i][0][j];
        if (tip[k]==tip[i] && win[p+1][k]==1)
          {
          win[p][i]=1;
          break;
          }
        else
        if (tip[k]!=tip[i] && win[p+1][k]==0)
          {
          win[p][i]=1;
          break;
          }
        }
      }
    else
      {
      /* use the white list */
      for (j=1;j<=nel[i][1];j++)
        {
        k=list[i][1][j];
        if (tip[k]==tip[i] && win[p+1][k]==1)
          {
          win[p][i]=1;
          break;
          }
        else
        if (tip[k]!=tip[i] && win[p+1][k]==0)
          {
          win[p][i]=1;
          break;
          }
        }
      }
    }
}

void play(void)
{
long i,j,k,poz,owner;

poz=1;
owner=start;

while (poz<l)
  {
  if (tip[owner]==1)
    /* it is a red dwarf's turn */
    owner=getNext();
  else
    /* it is a green dwarf's turn -> that's me :) */
    if (necklace[poz]=='B')
      {
      /* use the black list */
      if (win[poz][owner]==0)
        {
        setNext(list[poz][0][1]);
        owner=list[poz][0][1];
        }
      else
        {
        for (j=1;j<=nel[owner][0];j++)
          {
          k=list[owner][0][j];
          if (tip[k]==tip[owner] && win[poz+1][k]==1)
            {
            setNext(k);
            owner=k;
            break;
            }
          else
          if (tip[k]!=tip[owner] && win[poz+1][k]==0)
            {
            setNext(k);
            owner=k;
            break;
            }
          }
        }
      }
    else
      {
      /* use the white list */
      if (win[poz][owner]==0)
        {
        setNext(list[poz][1][1]);
        owner=list[poz][1][1];
        }
      else
        {
        for (j=1;j<=nel[owner][1];j++)
          {
          k=list[owner][1][j];
          if (tip[k]==tip[owner] && win[poz+1][k]==1)
            {
            setNext(k);
            owner=k;
            break;
            }
          else
          if (tip[k]!=tip[owner] && win[poz+1][k]==0)
            {
            setNext(k);
            owner=k;
            break;
            }
          }
        }
      }

  poz++;
  }

finish();
}
