/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

/* Time Complexity: O(N^3) */

/* Score: 90 points (TLE on 10% of the test cases) */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define filein "register.in"
#define fileout "register.out"
#define maxn 800

long a[2*maxn],s[maxn],o[maxn];
char A[maxn][maxn];
long n;

void readdata(void);
void compute(void);
void writedata(long);

int main()
{
readdata();
compute();
writedata(1);
return 0;
}

void readdata(void)
{
long i;

freopen(filein,"r",stdin);
scanf("%ld",&n);

for (i=1;i<=2*n;i++)
  scanf("%ld",&a[i]);
}

void swaprows(long r1,long r2)
{
long p;
char v;

for (p=1;p<=n+1;p++)
  {
  v=A[r1][p]; A[r1][p]=A[r2][p]; A[r2][p]=v;
  }
}

void swapcolumns(long c1,long c2)
{
long p,v;

for (p=1;p<=n;p++)
  {
  v=A[p][c1]; A[p][c1]=A[p][c2]; A[p][c2]=v;
  }

v=o[c1]; o[c1]=o[c2]; o[c2]=v;
}

void Gauss(void)
{
long i,j,p,q,done;

for (i=1;i<=n;i++)
  o[i]=i;

for (j=1;j<=n;j++)
  {
  if (A[j][j]==0)
    {
    /* A[j][j] must become 1 */
    for (done=0,q=j;q<=n;q++)
      {
      for (p=j;p<=n;p++)
	if (A[p][q]==1)
	  {
	  swaprows(j,p);
	  swapcolumns(j,q);

	  done=1;
	  break;
	  }

      if (done) break;
      }
    }

  if (A[j][j]==0)
    break;

  /* A[j][j] is 1 now */
  for (i=1;i<=n;i++)
    if (i!=j && A[i][j]==1)
      {
      for (p=1;p<=n+1;p++)
	A[i][p]^=A[j][p];
      }
  }

/* find the array s */
for (i=1;i<=n;i++)
  if (A[i][i]==1)
    s[o[i]]=A[i][n+1];
  else
    {
    s[o[i]]=0;
    if (A[i][n+1]!=0)
      writedata(0);
    }
}

void compute(void)
{
long i,j,k,p,q;

memset(A,0,sizeof(A));
for (i=n+1;i<=2*n;i++)
  {
  for (j=1;j<=n;j++)
    A[i-n][j]=a[i-j];
  A[i-n][n+1]=a[i];
  }

Gauss();
}

void writedata(long ok)
{
long i;

freopen(fileout,"w",stdout);

if (!ok)
  printf("-1\n");
else
  {
  for (i=1;i<=n;i++)
    {
    if (i>1)
      printf(" ");
    printf("%ld",s[i]);
    }
  printf("\n");
  }

exit(0);
}
