/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

/* Score: 74 points */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#define filein "therace.in"
#define fileout "therace.out"
#define maxn 250100
#define maxv 101
#define maxpass 10000
#define P 1000000
#define eps 1e-6
#define infinit 1e30

double x[maxn],v[maxn],time[maxn],poz[maxn];
long who[maxn],where[maxn],howmany[maxv],next[maxn],prev[maxn];
long n,dimheap,npasses;

void readdata(void);
void precompute(void);
void compute(void);

int main()
{
readdata();
precompute();
compute();
return 0;
}

void readdata(void)
{
long i;

freopen(filein,"r",stdin);
scanf("%ld",&n);
for (i=1;i<=n;i++)
  scanf("%lf %lf",&x[i],&v[i]);
}

void addtoheap(double t,double px,long i)
{
long p,tata,laux;
double daux;

dimheap++;
time[dimheap]=t;
poz[dimheap]=px;
who[dimheap]=i;
where[i]=dimheap;

p=dimheap;
tata=p>>1;

while (tata>0 && ((time[tata]>time[p] && fabs(time[tata]-time[p])>eps)
                 ||
                 (fabs(time[tata]-time[p])<eps && poz[tata]>poz[p])))
  {
  /* switch tata & p */
  daux=time[tata];
  time[tata]=time[p];
  time[p]=daux;

  daux=poz[tata];
  poz[tata]=poz[p];
  poz[p]=daux;

  laux=who[tata];
  who[tata]=who[p];
  who[p]=laux;

  where[who[tata]]=tata;
  where[who[p]]=p;

  p=tata;
  tata=tata>>1;
  }
}

long lift(long pozy)
{
long p,tata,laux;
double daux;

p=pozy;
tata=p>>1;

while (tata>0 && ((time[tata]>time[p] && fabs(time[tata]-time[p])>eps)
                 ||
                 (fabs(time[tata]-time[p])<eps && poz[tata]>poz[p])))
  {
  /* switch tata & p */
  daux=time[tata];
  time[tata]=time[p];
  time[p]=daux;

  daux=poz[tata];
  poz[tata]=poz[p];
  poz[p]=daux;

  laux=who[tata];
  who[tata]=who[p];
  who[p]=laux;

  where[who[tata]]=tata;
  where[who[p]]=p;

  p=tata;
  tata=tata>>1;
  }

return p;
}

void removefromheap(long pozy)
{
long p,p1,p2,ok,laux;
double t,t1,t2,px,px1,px2,daux;

where[who[pozy]]=0;

if (dimheap==1)
  dimheap=0;
else
  {
  time[pozy]=time[dimheap];
  poz[pozy]=poz[dimheap];
  who[pozy]=who[dimheap];
  where[who[pozy]]=pozy;
  dimheap--;

  ok=1; p=lift(pozy);
  while (ok)
    {
    ok=0;
    t=time[p];
    px=poz[p];

    p1=p<<1;
    if (p1<=dimheap)
      {
      t1=time[p1];
      px1=poz[p1];
      }
    else
      t1=px1=infinit;

    p2=p1+1;
    if (p2<=dimheap)
      {
      t2=time[p2];
      px2=poz[p2];
      }
    else
      t2=px2=infinit;

    if (t1<t2 || (fabs(t1-t2)<eps && px1<px2))
      {
      if (t1<t || (fabs(t1-t)<eps && px1<px))
        {
        /* switch p & p1 */
        daux=time[p];
        time[p]=time[p1];
        time[p1]=daux;

        daux=poz[p];
        poz[p]=poz[p1];
        poz[p1]=daux;

        laux=who[p];
        who[p]=who[p1];
        who[p1]=laux;

        where[who[p]]=p;
        where[who[p1]]=p1;

        p=p1;
        ok=1;
        }
      }
    else
      {
      if (t2<t || (fabs(t2-t)<eps && px2<px))
        {
        /* switch p & p2 */
        daux=time[p];
        time[p]=time[p2];
        time[p2]=daux;

        daux=poz[p];
        poz[p]=poz[p2];
        poz[p2]=daux;

        laux=who[p];
        who[p]=who[p2];
        who[p2]=laux;

        where[who[p]]=p;
        where[who[p2]]=p2;

        p=p2;
        ok=1;
        }
      }
    }
  }
}

void precompute(void)
{
long i,j;
double t,p;

memset(howmany,0,sizeof(howmany));
memset(next,0,sizeof(next));
memset(prev,0,sizeof(prev));

for (dimheap=0,i=n;i>=1;i--)
  {
  npasses=(npasses+howmany[(long)(v[i])])%P;

  j=i+1;
  if (i<n && v[i]>v[j])
    {
    t=(x[j]-x[i])/(v[i]-v[j]);
    p=x[i]+t*v[i];
    addtoheap(t,p,i);
    }

  for (j=v[i]+1;j<maxv;j++)
    howmany[j]++;

  if (i<n)
    next[i]=i+1;
  if (i>1)
    prev[i]=i-1;
  }
}

void compute(void)
{
long i,j,k,npass;
double t1,t,px;

freopen(fileout,"w",stdout);
printf("%ld\n",npasses);

npass=0;
while (npass<maxpass && dimheap>0)
  {
  i=who[1];
  j=next[i];
  printf("%ld %ld\n",i,j);
  npass++;

  next[i]=next[j];
  prev[next[i]]=i;
  prev[j]=prev[i];
  next[prev[j]]=j;
  next[j]=i;
  prev[i]=j;
  
  /* update the heap */
  t1=time[1];
  removefromheap(1);

  if (next[i]>0 && v[i]>v[next[i]])
    {
    k=next[i];
    t=(x[k]+v[k]*t1-x[i]-v[i]*t1)/(v[i]-v[k]);
    px=x[i]+v[i]*t1+v[i]*t;

    if (t>0 || fabs(t)<eps)
      {
      t+=t1;
      addtoheap(t,px,i);
      }
    }

  if (prev[j]>0 && v[prev[j]]>v[j])
    {
    k=prev[j];
    t=(x[j]+v[j]*t1-x[k]-v[k]*t1)/(v[k]-v[j]);
    px=x[k]+v[k]*t1+v[k]*t;

    if (t>0 || fabs(t)<eps)
      {
      t+=t1;

      if (where[k]>0)
        removefromheap(where[k]);

      addtoheap(t,px,k);
      }
    }
  }
}
