#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define NMAX 20010

int b[NMAX], poz[NMAX], nocup[NMAX], s[NMAX], d[NMAX], pnew[NMAX], stki[NMAX], stkp[NMAX], MAXMOVES;
int i, N, Nini, Nc, c, leftc, len, cnt, nmoves, left, lleft, right, p, q, pprev, empty, lev, lbest, rbest, minlen, dmin, dmax, davg, dmmin, dmmax, dd, okinarow, cntdmax, maxokinarow, newpoz, ninc, lastPoz;

void readInput(void)
{
	scanf("%d", &N);
	// N = 20000;
	Nini = N / 4;
	Nc = N / 4;

	memset(b, 0, sizeof(b));

	for (i = 1; i <= Nini; i++)
	{
		printf("%d\n", (i - 1) * 4 + 1);
		b[(i - 1) * 4 + 1] = i;
		poz[i] = (i - 1) * 4 + 1;
	}

	MAXMOVES = 1;
	while (MAXMOVES * MAXMOVES <= N)
		MAXMOVES++;

	if ((MAXMOVES - 1) * (MAXMOVES - 1) == N)
		MAXMOVES--;

	MAXMOVES = 150;

	srand(8282);
}

int nboxes(int p1, int p2)
{
	if (p2 >= p1)
		return nocup[p2] - nocup[p1 - 1];
	else
		return nocup[N] - nocup[p1 - 1] + nocup[p2];
}

int decPoz(int poz)
{
	if (poz > 1) return (poz - 1);
	else return N;
}

int incPoz(int poz)
{
	if (poz < N) return (poz + 1);
	else return 1;
}

int countPoz(int p1, int p2)
{
	if (p2 >= p1)
		return p2 - p1 + 1;
	else
		return (N - p1 + 1) + p2;
}

int addPoz(int poz, int x)
{
	if (poz + x <= N) return (poz + x);
	else return x - (N - poz);
}

void recomputePrefixSums(void)
{
	nocup[0] = 0;
	for (i = 1; i <= N; i++)
		if (b[i] > 0)
			nocup[i] = nocup[i - 1] + 1;
		else
			nocup[i] = nocup[i - 1];
}

void printStatus(void)
{
	for (i = 1; i <= N; i++)
		if (b[i] > 0)
			fprintf(stderr, "%d ", b[i]);
		else
			fprintf(stderr, "- ");
	fprintf(stderr, "\n");
}

void doMove(int x, int newpoz)
{
	if (poz[x] == newpoz)
		return;

	if (b[newpoz] != 0)
	{
		printStatus();
		fprintf(stderr, "ERROR! Trying to move to a non-empty position: M %d %d\n", x, newpoz);
		exit(0);
	}

	b[poz[x]] = 0;
	b[newpoz] = x;
	poz[x] = newpoz;
	printf("M %d %d\n", x, newpoz);
	nmoves++;
}

void computeNewPositions(int cnt, int len, int leftc)
{
	for (i = 1; i <= len; i++)
		if (s[i] == leftc)
			cnt++;

	if (dmmin >= (len - cnt) / (cnt + 1))
		return;

	// fprintf(stderr, "left=%d, right=%d, cnt=%d, len=%d, leftc=%d\n", left, right, cnt, len, leftc);

	empty = len - cnt;
	for (i = 1; i <= cnt; i++)
	{
		d[i] = (len - cnt) / (cnt + 1);
		empty -= d[i];
	}

	empty -= (len - cnt) / (cnt + 1);

	if (empty > 0)
	{
		q = 0;
		for (i = 1; i <= len; i++)
		{
			if (s[i] > 0)
				q++;

			if (s[i] == leftc)
			{
				q++;
				d[q]++;
				empty--;
				break;
			}
		}
	}

	p = 1;
	while (empty > 0 && p <= cnt)
	{
		if (p != q)
		{
			d[p]++;
			empty--;
		}

		p++;
	}

	pnew[1] = d[1] + 1;
	for (i = 2; i <= cnt; i++)
		pnew[i] = pnew[i - 1] + d[i] + 1;

	p = 0;
	lev = 0;
	for (i = 1; i <= len; i++)
		if (s[i] > 0)
		{
			p++;
			if (pnew[p] < i)
			{
				while (lev > 0)
				{
					doMove(s[stki[lev]], addPoz(left, pnew[stkp[lev]] - 1));
					lev--;
				}

				doMove(s[i], addPoz(left, pnew[p] - 1));
			}
			else
			{
				lev++;
				stki[lev] = i;
				stkp[lev] = p;
			}

			if (s[i] == leftc)
				p++;
		}

	while (lev > 0)
	{
		doMove(s[stki[lev]], addPoz(left, pnew[stkp[lev]] - 1));
		lev--;
	}

	//printStatus();
}

void processOperations(void)
{
	//printStatus();

	lastPoz = 1;

	for (c = Nini + 1; c <= Nini + Nc; c++)
	{
		scanf("%d", &leftc);
		// leftc = 10; /* Nini - (rand() % 3);*/ 1 + (rand() % (c - 1));
		// fprintf(stderr, "New Box %d: %d\n", c, leftc);

		recomputePrefixSums();

		nmoves = 0;
		if (c > Nini + 1 && leftc != c - 1)
		{
			// adjust box c - 1
			left = poz[c - 1];
			right = poz[c - 1];
			while (b[incPoz(right)] == 0)
				right = incPoz(right);

			len = countPoz(left, right);
			cnt = nboxes(left, right);

			for (p = left; p != incPoz(right); p = incPoz(p))
				if (b[p] > 0)
					s[countPoz(left, p)] = b[p];
				else
					s[countPoz(left, p)] = 0;

			dmmin = -1;
			computeNewPositions(cnt, len, leftc);
			recomputePrefixSums();
		}

		left = right = poz[leftc];
		while (nboxes(left, right) < MAXMOVES - nmoves && countPoz(left, right) <= N - 3 /*N - 2*/)
		{
			left = decPoz(left);
			right = incPoz(right);
		}

		if (nboxes(left, right) > MAXMOVES - nmoves)
		{
			if (b[left] > 0 && left != leftc)
				left = incPoz(left);
			else
				right = decPoz(right);
		}

		while (countPoz(left, right) <= N - 1)
		{
			if (b[decPoz(left)] == 0)
				left = decPoz(left);
			else
				break;
		}

		while (countPoz(left, right) <= N - 1)
		{
			if (b[incPoz(right)] == 0)
				right = incPoz(right);
			else
				break;
		}

		len = countPoz(left, right);
		cnt = nboxes(left, right);

		for (p = left; p != incPoz(right); p = incPoz(p))
			if (b[p] > 0)
				s[countPoz(left, p)] = b[p];
			else
				s[countPoz(left, p)] = 0;

		dmmin = -1;
		computeNewPositions(cnt, len, leftc);
		recomputePrefixSums();

		// fprintf(stderr, "[adjusting]\n");

		/*
		dmin = (N - c) / c;
		dmax = dmin;
		if ((N - c) % c > 0)
			dmax++;

		if ((N - c) % c == 0)
			maxokinarow = N + 1;
		else
		{
			cntdmax = (N - c) % c;
			maxokinarow = 1 + (c / cntdmax);
		}
		*/

		dmin = dmax = 1;
		maxokinarow = N;

		left = lastPoz;
		while (b[left] == 0)
			left = incPoz(left);

		okinarow = 0;
		for (pprev = left, p = incPoz(left); p != left && nmoves < MAXMOVES; p = incPoz(p))
			if (b[p] > 0)
			{
				dd = countPoz(pprev, p) - 2;
				if (dd > dmax /* || (dd == dmax && okinarow > maxokinarow)*/)
				{
					pprev = addPoz(pprev, dmin + 1);
					doMove(b[p], pprev);
					okinarow = 0;
				}
				else
				{
					pprev = p;
					if (dd == dmax)
						okinarow++;
					else
						okinarow = 0;
				}
			}

		lastPoz = pprev;

		/*
		for (ninc = 1, lleft = 1 + (rand() % N); ninc <= N && nmoves < MAXMOVES; lleft = incPoz(lleft), ninc++)
		{
			right = left = lleft;
			while (nboxes(left, right) < MAXMOVES - nmoves && countPoz(left, right) <= N - 2)
				right = incPoz(right);

			while (countPoz(left, right) <= N - 1)
			{
				if (b[decPoz(left)] == 0)
					left = decPoz(left);
				else
					break;
			}

			while (countPoz(left, right) <= N - 1)
			{
				if (b[incPoz(right)] == 0)
					right = incPoz(right);
				else
					break;
			}

			// check if the interval [left,right] is balanced
			len = countPoz(left, right);
			cnt = nboxes(left, right);

			davg = 0;
			dmmin = N;
			dmmax = 0;
			q = 0;
			pprev = decPoz(left);
			for (p = left; p != incPoz(right); p = incPoz(p))
				if (b[p] > 0)
				{
					q++;
					davg += countPoz(pprev, p) - 2;
					if (countPoz(pprev, p) - 2 < dmmin)
						dmmin = countPoz(pprev, p) - 2;
					if (countPoz(pprev, p) - 2 > dmmax)
						dmmax = countPoz(pprev, p) - 2;
					pprev = p;
				}

			davg /= (cnt + 1);

			if (dmmin < dmin || dmmax > dmin + 1)
			{
				for (p = left; p != incPoz(right); p = incPoz(p))
					if (b[p] > 0)
						s[countPoz(left, p)] = b[p];
					else
						s[countPoz(left, p)] = 0;

				computeNewPositions(cnt, len, leftc);
				recomputePrefixSums();
			}
		}
		*/

		printf("DONE\n");
		// fprintf(stderr, "nmoves=%d\n", nmoves);

		if (b[incPoz(poz[leftc])] > 0)
		{
			fprintf(stderr, "wtf?\n");
			return;
		}

		b[incPoz(poz[leftc])] = c;
		poz[c] = incPoz(poz[leftc]);

		//printStatus();
	}

	//printStatus();
}

int main()
{
	readInput();
	processOperations();
	return 0;
}