#include <stdio.h>
#include <assert.h>
#include <algorithm>
#include <vector>
using namespace std;

#define MAX_N 100005
#define FIN "harbingers.in"
#define FOUT "harbingers.out"
#define EPS 1e-10
#define ll long long
#define mp make_pair
#define pb push_back
#define f first
#define s second

typedef pair<int, int> edge;
typedef pair<int, double> entry;

int N, S[MAX_N], V[MAX_N], D[MAX_N], up[MAX_N], len[MAX_N], stklen;
vector<edge> G[MAX_N];
pair<int, entry> save[MAX_N];
entry stk[MAX_N];
ll C[MAX_N];

inline double intersect(int i, int j) {
  return (double) (C[i] - C[j]) / (D[i] - D[j]);
}

inline void insert(int idx) {
  double t = 0.0;

  while (stklen > 0 && (t = intersect(idx, stk[stklen-1].f)) <
      stk[stklen-1].s+EPS) --stklen;
  save[idx] = mp(stklen, stk[stklen]);
  stk[stklen++] = mp(idx, t);
}

inline void compute(int n) {
  C[n] = S[n] + (ll)V[n]*D[n];
  for (int i = stklen-1; i >= 0; --i)
    if (stk[i].s < V[n] + EPS) {
      C[n] += (ll)-D[stk[i].f]*V[n] + C[stk[i].f];
      break;
    }
}

void DFS(int n) {
  vector<edge>::iterator it;

  compute(n);
  len[n] = stklen;
  insert(n);
  for (it = G[n].begin(); it != G[n].end(); ++it) {
    if (it->f == up[n]) continue;
    D[it->f] = D[n] + it->s;
    up[it->f] = n;
    DFS(it->f);
  }
  stk[save[n].f] = save[n].s;
  stklen = len[n];
}

int main(void) {
  int i, a, b, c;

  freopen(FIN, "r", stdin);
  freopen(FOUT, "w", stdout);

  scanf("%d", &N);
  assert(3 <= N && N <= 100000);
  for (i = 1; i < N; ++i) {
    scanf("%d %d %d", &a, &b, &c);
    assert(1 <= a && a <= N);
    assert(1 <= b && b <= N);
    assert(0 <= c && c <= 10000);
    G[a].pb(mp(b, c));
    G[b].pb(mp(a, c));
  }
  for (i = 2; i <= N; ++i) {
    scanf("%d %d", S+i, V+i);
    assert(0 <= S[i] && S[i] <= 1000000000);
    assert(1 <= V[i] && V[i] <= 1000000000);
  }

  DFS(1);

  for (i = 2; i <= N; ++i)
    printf("%lld%c", C[i], i < N ? ' ' : '\n');

  return 0;
}
