
/*
Problem: Photo
Author: Catalin-Stefan Tiseanu
Complexity: (2 ^ N) * N ^ 2, removal of extra points
Description: A BF search on 2 ^ N states
Intended points: 40
*/

#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define MAX_BRUTE 20
#define MAX_L 151
#define MAX_N (1<<MAX_BRUTE)
#define X first
#define Y second
#define oo 40011

int N, A, N_x;
vector< pair<int,int> > vp;
vector<int> v_x, v_y;
set<int> x_co;
int d[MAX_N], q[MAX_N]; 
int preproc[MAX_L][MAX_L];

int brute() {
  for ( int i = 0; i < N; ++i )
    for ( int j = i; j < N; ++j )
        for ( int o = 0; o < N; ++o ) {
          int mh = (1<<30);
          if ( i != j )
            mh = A / ( v_x[j] - v_x[i] ); 
             
          if ( v_x[o] >= v_x[i] && v_x[o] <= v_x[j] && v_y[o] <= mh )
            preproc[i][j] |= (1<<o);
      }
  
  for ( int l = 1, r = 1; l <= r && q[l] != (1<<N)-1; ++l ) {
    int el = q[l];
    for ( int i = 0; i < N; ++i )
      for ( int j = 0; j < N; ++j ) {
        int nel = el | preproc[i][j];      
        if ( !d[nel] )
          d[nel] = d[el] + 1,
          q[++r] = nel;
      }
  }
  
  return d[(1<<N)-1];
}

int main() {    
  freopen("photo.in", "r", stdin);
  freopen("photo.out", "w", stdout);  
  
  int x, y;
  
  scanf("%d %d", &N, &A);
  for ( int i = 1; i <= N; ++i ) {
    scanf("%d %d", &x, &y);
    vp.push_back( make_pair(x, y) );
    x_co.insert( x );
  }
  
  for ( set<int>::iterator it = x_co.begin(); it != x_co.end(); ++it )
    v_x.push_back( *it );
  N_x = v_x.size();;
  v_y = vector<int>( N_x, -1 );
  for ( int i = 0; i < N_x; ++i )
    for ( int j = 0; j < N; ++j )
      if ( vp[j].X == v_x[i] && vp[j].Y > v_y[i] )
        v_y[i] = vp[j].Y;
  N = N_x;
  
  printf("%d\n", brute() );
  
  return 0;    
}
