
/*
Problem: Photo
Author: Catalin-Stefan Tiseanu
Complexity: (2 ^ N) * N ^ 3
Description: A BF search on 2 ^ N states
Intended points: 20
*/

#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define MAX_BRUTE 20
#define MAX_L 151
#define MAX_N (1<<MAX_BRUTE)
#define X first
#define Y second
#define oo 40011

int N, A, N_x;
vector< pair<int,int> > vp;
vector< int > v_y;

int d[MAX_N], q[MAX_N]; 
int preproc[MAX_L][MAX_L][MAX_L];

int brute() {
  for ( int i = 0; i < N; ++i )
    for ( int j = i; j < N; ++j )
      for ( int k = 0; k < N; ++k )
        for ( int o = 0; o < N; ++o )
          if ( ((long long)vp[j].X - vp[i].X) * v_y[k] <= A && 
               vp[o].X >= vp[i].X && vp[o].X <= vp[j].X && vp[o].Y <= v_y[k] )
            preproc[i][j][k] |= (1<<o);
  
  for ( int l = 1, r = 1; l <= r && q[l] != (1<<N)-1; ++l ) {
    int el = q[l];
    for ( int i = 0; i < N; ++i )
      for ( int j = i; j < N; ++j )
        for ( int k = 0; k < N; ++k ) {
          int nel = el | preproc[i][j][k];      
          if ( !d[nel] && nel )
            d[nel] = d[el] + 1,
            q[++r] = nel;
        }
  }
  
  return d[(1<<N)-1];
}

int main() {    
  freopen("photo.in", "r", stdin);
  freopen("photo.out", "w", stdout);  
  
  int x, y;
  
  scanf("%d %d", &N, &A);
  for ( int i = 1; i <= N; ++i ) {
    scanf("%d %d", &x, &y);
    vp.push_back( make_pair(x, y) );
    v_y.push_back( y );
  }
  
  sort( v_y.begin(), v_y.end() );
  sort( vp.begin(), vp.end() );
  
  printf("%d\n", brute() );
  
  return 0;    
}
