/*
Author:        Catalin-Stefan Tiseanu
Complexity:    2^N * N^2
Description:   A BF search on 2^N states
*/

#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define MAX_BRUTE 20
#define MAX_N (1<<MAX_BRUTE)
#define X first
#define Y second
#define oo 40011

int N, A, N_x;
vector< pair<int,int> > vp;
set<int> y_co, x_co;
vector<int> v_x;
vector< vector<int> > v_y;

int d[MAX_N], q[MAX_N]; 
int preproc[MAX_BRUTE][MAX_BRUTE];

int brute() {
  for ( int i = 1; i <= N_x; ++i )
    for ( int j = i; j <= N_x; ++j )
        for ( int o = 0; o < vp.size(); ++o ) {
          int mh = (1<<30);
          if ( i != j )
            mh = A / ( v_x[j] - v_x[i] ); 
             
          if ( vp[o].X >= v_x[i] && vp[o].X <= v_x[j] && vp[o].Y <= mh )
            preproc[i][j] |= (1<<o);
      }
  
  for ( int l = 1, r = 1; l <= r && q[l] != (1<<N)-1; ++l ) {
    int el = q[l];
    for ( int i = 1; i <= N_x; ++i )
      for ( int j = i; j <= N_x; ++j ) {
        int nel = el | preproc[i][j];      
        if ( !d[nel] )
          d[nel] = d[el] + 1,
          q[++r] = nel;
      }
  }
  
  return d[(1<<N)-1];
}

int main() {    
  freopen("photo.in", "r", stdin);
  freopen("photo.out", "w", stdout);  
  
  int x, y;
  
  scanf("%d %d", &N, &A);
  for ( int i = 1; i <= N; ++i ) {
    scanf("%d %d", &x, &y);
    vp.push_back( make_pair(x, y) );
    y_co.insert( y );
    x_co.insert( x );
  }
  
  v_x.push_back( -oo );
  for ( set<int>::iterator it = x_co.begin(); it != x_co.end(); ++it )
    v_x.push_back( *it );
  N_x = v_x.size() - 1;
  v_y.resize(N_x+1);
  for ( int i = 1; i <= N_x; ++i )
    for ( int j = 0; j < N; ++j )
      if ( vp[j].X == v_x[i] )
        v_y[i].push_back( vp[j].Y );
  for ( int i = 1; i <= N_x; ++i )
    sort( v_y[i].begin(), v_y[i].end() );
  
  sort( vp.begin(), vp.end() );
  
  printf("%d\n", brute() );
  
  return 0;    
}
