#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <algorithm>
#include <vector>

using namespace std;

const int MAX_N = 200;

int N;
int A;
int max_x;
int num_rectangles;

int height[MAX_N];
int width[MAX_N];
int left[MAX_N];

FILE *f;

void random_fill() {
  for (int i = 0; i < N; ++i) {
    int rect = rand() % num_rectangles;
    int x = rand() % (width[rect] + 1) + left[rect];
    int y = 1 + rand() % height[rect];
    fprintf(f, "%d %d\n", x, y);
  }
}

void corner_and_random_fill() {
  int n = N;
  for (int i = 0; i < num_rectangles && n > 1; ++i) {
    if (rand() % 2) {
      fprintf(f, "%d %d\n", left[i], max(rand() % 2 + 1, height[i] - rand() % 2));
      fprintf(f, "%d %d\n", left[i] + width[i], 1 + rand() % height[i]);
    } else {
      fprintf(f, "%d %d\n", left[i], 1 + rand() % height[i]);
      fprintf(f, "%d %d\n", left[i] + width[i], max(rand() % 2 + 1, height[i] - rand() % 2));
    }
    n -= 2;
  }
  for (int i = 0; i < n; ++i) {
    int rect = rand() % num_rectangles;
    int x = 1 + rand() % width[rect] + left[rect];
    int y = 1 + rand() % height[rect];
    fprintf(f, "%d %d\n", x, y);
  }
}

void reunion_fill() {
  int n = N;
  vector<pair<int, int> > height_for;
  for (int x = 0; x <= max_x && n; ++x) {
    int max_height = -1;
    int rect = -1;
    for (int i = 0; i < num_rectangles; ++i) {
      if (left[i] <= x && x <= left[i] + width[i]) {
        max_height = max(max_height, height[i]);
        rect = i;
      }
    }
    if (max_height == -1) {
      continue;
    }

    //printf("x = %d, max_height = %d\n", x, max_height);
    if (left[rect] == x || left[rect] + width[rect] == x) {
      int y;
      if (max_height > 3) {
        y = max_height - rand() % (max_height / 4);
      } else {
        y = max_height;
      }
      fprintf(f, "%d %d\n", x, y);
      n --;
    } else {
      height_for.push_back(make_pair(x, max_height));
    }
  }
  printf("size = %d\n", height_for.size());
  for (int i = 1; i < (int) height_for.size(); ++i) {
    int p = rand() % (i + 1);
    swap(height_for[i], height_for[p]);
  }
  for (int i = 0; i < (int) height_for.size() && n; ++i) {
    int y, maxy = height_for[i].second;
    if (maxy > 3) {
      y = maxy - rand() % (maxy / 4);
    } else {
      y = maxy;
    }
    fprintf(f, "%d %d\n", height_for[i].first, y);
    n --;
  }
  while (n) {
    int rect = rand() % num_rectangles;
    int x = rand() % (width[rect] + 1) + left[rect];
    int y = 1 + rand() % height[rect];
    fprintf(f, "%d %d\n", x, y);
  }
}

void heights_for_rectangles() {
  int log_A = 0;
  for (; 1 << (log_A) <= A; ++log_A)
    ;
  for (int i = 0; i < num_rectangles; ++i) {
    int group = rand() % log_A;
    height[i] = (1 << group) + random() % (1 << group);
    height[i] = min(height[i], A);
  }
  sort(height + 0, height + num_rectangles);
  for (int i = 0; i < num_rectangles; ++i) {
    printf("%d ", height[i]);
  }
  printf("\n");
}

void heights_for_rectangles_2() {
  int NUM_SMALL_RECTS = 3;
  for (int i = 0; i < NUM_SMALL_RECTS; ++i) {
    height[i] = rand() % 8 + 1;
  }
  for (int i = NUM_SMALL_RECTS; i < num_rectangles; ++i) {
    height[i] = min(A, i * i);
  }
  sort(height + 0, height + num_rectangles);
  for (int i = 0; i < num_rectangles; ++i) {
    printf("%d ", height[i]);
  }
  printf("\n");
}

void heights_for_rectangles_3() {
  int log_A = 0;
  int pos = 0;
  for (; 1 << (log_A) <= A; ++log_A) {
    for (int j = 0; j < (log_A) / 3; ++j) {
      height[pos] = (1 << log_A) + rand() % (1 << log_A);
      height[pos] = min(height[pos], A - rand() % 10);
      ++pos;
    }
  }
  printf("pos = %d\n", pos);
  for (int i = pos; i < num_rectangles; ++i) {
    int group = rand() % log_A;
    if (group < 2) {
      group = rand() % log_A;
    }
    height[i] = (1 << group) + rand() % (1 << group);
    height[i] = min(height[i], A);
  }
  sort(height + 0, height + num_rectangles);
  for (int i = 0; i < num_rectangles; ++i) {
    printf("%d ", height[i]);
  }
  printf("\n");
}

bool intersects(int r) {
  for (int j = 0; j < r; ++j) {
    if (left[j] < left[r] && left[r] + width[r] < left[j] + width[j])
      continue;
    if (left[j] == left[r] || left[j] == left[r] + width[r] ||
        left[j] + width[j] == left[r] || left[j] + width[j] == left[r] + width[r]) {
      return true;
    }
    if ((left[j] < left[r] && left[r] < left[j] + width[j]) ||
        (left[r] < left[j] && left[j] < left[r] + width[r])) {
      return true;
    }
  }
  return false;
}

void positions_for_rectangles() {
  for (int i = 0; i < num_rectangles; ++i) {
    width[i] = A / height[i];
  }
  for (int i = 0; i < num_rectangles; ++i) {
    do {
      left[i] = rand() % max_x;
    } while (intersects(i));
  }
  for (int i = 0; i < num_rectangles; ++i) {
    printf("%d ", left[i]);
  }
  int count = 0;
  for (int i = 0; i < num_rectangles; ++i) {
    for (int j = 0; j < i; ++j) {
      if (left[j] <= left[i] && left[i] + width[i] <= left[j] + width[j]) {
        count++;
      }
    }
  }
  printf("\ncount = %d\n", count);
}

void positions_for_rectangles_with_inclusions() {
  const int THRESHOLD = 4;
  for (int i = 0; i < num_rectangles; ++i) {
    width[i] = A / height[i];
  }
  for (int i = 0; i < num_rectangles; ++i) {
    if (height[i] <= THRESHOLD || i < 1) {
      do {
        left[i] = rand() % max_x;
      } while (intersects(i));
    } else {
      bool ok;
      int count = 100;
      do {
        int rect = rand() % i;
        ok = false;
        if (width[rect] - width[i] - 1 > 0) {
          left[i] = left[rect] + 1 + rand() % (width[rect] - width[i] - 1);
          //printf("rect = %d, width[rect] = %d, width[i] = %d, left[i] = %d, left[rect] = %d\n",
          //    rect, width[rect], width[i], left[i], left[rect]);
          ok = !intersects(i);
        }
        --count;
      } while (!ok && count > 0);
      if (!count) {
        do {
          left[i] = rand() % max_x;
        } while (intersects(i));
      }
    }
  }
  printf("left:\n");
  for (int i = 0; i < num_rectangles; ++i) {
    printf("%d ", left[i]);
  }
  int count = 0;
  for (int i = 0; i < num_rectangles; ++i) {
    for (int j = 0; j < i; ++j) {
      if (left[j] < left[i] && left[i] + width[i] < left[j] + width[j]) {
        count++;
      }
    }
  }
  printf("\ncount = %d\n", count);
}
typedef void (*ptr2method) (void) ;

const int NUM_TESTS = 1;
ptr2method tests[][3] = {
//  {heights_for_rectangles,   positions_for_rectangles_with_inclusions, corner_and_random_fill},
//  {heights_for_rectangles_2, positions_for_rectangles_with_inclusions, corner_and_random_fill},
//  {heights_for_rectangles_3, positions_for_rectangles_with_inclusions, reunion_fill},
//  {heights_for_rectangles_3, positions_for_rectangles_with_inclusions, corner_and_random_fill},
//  {heights_for_rectangles, positions_for_rectangles_with_inclusions, reunion_fill},
  {heights_for_rectangles_3, positions_for_rectangles_with_inclusions, reunion_fill},
};
int test_dim[][4] = {
// {   N,       A,   n_rect,     max_X}
//   { 125,     204,       25,     10000},
//   { 150,     400,       40,     40000},
//   { 175,    1000,       33,     30000},
//   { 200,   16001,       41,    60000},
//   { 200,  200000,       55,   3000000},
   { 200,    3000,       77,   400000},
};

int main() {
  srand(time(0));

  for (int i = 0; i < NUM_TESTS; ++i) {
    char test_name[32];
    sprintf(test_name, "%d-photo.in.generated", i + 5);
    f = fopen(test_name, "w");
    N = test_dim[i][0];
    A = test_dim[i][1];
    num_rectangles = test_dim[i][2];
    max_x = test_dim[i][3];
    fprintf(f, "%d %d\n", N, A);
    tests[i][0]();
    tests[i][1]();
    tests[i][2]();
    fclose(f);
  }
  return 0;
}

