#include <stdio.h>
#include <stdlib.h>

#define MAXN    204

int n, A, pt[MAXN][3];
int heights[MAXN];
typedef unsigned char array[MAXN][MAXN];
array realt[MAXN];

#define t  ((array *) &realt[1][1][1])

int cmp_int(int *p, int *q)
{
  return(*p - *q);
}

inline int search(int x)
{
  int lo = 0, hi = n + 2, mid;

  while(hi - lo > 1) {
    mid = (lo + hi) / 2;
    if(heights[mid - 1] <= x)
      lo = mid;
    else hi = mid;
  }
  return(lo);
}

void sweep(int i, int j)
{
  int mark[MAXN], k, maxh, min;

  for(k = 0; k <= n; k++)
    mark[k] = -1;
  for(k = i; k <= j; k++)
    mark[pt[k][2]] = k;

  // initialize with rectangle i->j
  maxh = (pt[j][0] - pt[i][0]) ? (A / (pt[j][0] - pt[i][0])) : A;
  if((pt[i][1] <= maxh) && (pt[j][1] <= maxh))
    min = t[i + 1][j - 1][search(maxh)] + 1;
  else min = MAXN + 1;
 
  // initialize with [i,k] + [k+1,j]
  for(k = i; k < j; k++)
    if(t[i][k][0] + t[k + 1][j][0] < min)
      min = t[i][k][0] + t[k + 1][j][0];

  for(k = 0; k <= n; k++) {
    t[i][j][k] = min;
    if((mark[k] != -1) &&
       (t[i][mark[k] - 1][k + 1] + t[mark[k] + 1][j][k + 1] < min))
      min = t[i][mark[k] - 1][k + 1] + t[mark[k] + 1][j][k + 1];
  }
}

int main()
{
  int i, j, k;

  freopen("photo.in", "r", stdin);
  scanf("%d%d", &n, &A);
  for(i = 0; i < n; i++)
    scanf("%d%d", pt[i], pt[i] + 1);
  qsort(pt, n, sizeof(*pt), (void *) cmp_int);

  for(i = 0; i < n; i++)
    heights[i] = pt[i][1];
  qsort(heights, n + 1, sizeof(*heights), (void *) cmp_int);
  heights[n + 1] = 2000000000;

  for(i = 0; i < n; i++)
    for(j = 1; j <= n; j++)
      if(heights[j] == pt[i][1]) {
	pt[i][2] = j;
	heights[j] = -heights[j];
	break;
      }
  for(i = 1; i <= n; i++)
    heights[i] = -heights[i];

  for(i = 0; i < n; i++)
    for(j = 0; j <= pt[i][2]; j++)
      t[i][i][j] = 1;

  for(i = 1; i < n; i++) //delta
    for(j = i; j < n; j++)
      sweep(j - i, j);

  freopen("photo.out", "w", stdout);
  printf("%d\n", t[0][n-1][0]);
  return(0);
}
