/*
Author:        Silviu-Ionuţ Gănceanu
Description:   Assumes all rectangles are disjoint. Should score 0 points.
*/

#include <cstdio>
#include <cstring>
#include <ctime>
#include <algorithm>
#include <vector>
#include <utility>

using namespace std;

const int MAX_N = 200;

#define xx first
#define yy second
int N, A;
vector<pair<int, int> > point;

void read_data() {
  FILE *f = fopen("photo.in", "r");
  fscanf(f, "%d %d", &N, &A);
  point.reserve(N);
  int x, y;
  for (int i = 0; i < N; ++i) {
    fscanf(f, "%d %d", &x, &y);
    point.push_back(make_pair(x, y));
  }
  fclose(f);
}

bool cmpf(const pair<int, int> &a, const pair<int, int> &b) {
  if (a.xx - b.xx)
    return a.xx < b.xx;
  return a.yy > b.yy;
}

bool equalf(const pair<int, int> &a, const pair<int, int> &b) {
  return a.xx == b.xx;
}

int best[MAX_N + 1];
void solve_and_print() {
  // TODO(silviug): check that indeed the points are erased corectly.
  srand(time(0));
  sort(point.begin(), point.end(), cmpf);
  point.erase(unique(point.begin(), point.end(), equalf), point.end());

  for (int i = 0; i < N; ++i) {
    int max_y = point[i].yy;
    int min_x = point[i].xx;
    int max_x = point[i].xx;
    best[i + 1] = best[i] + 1;
    for (int j = i - 1; j >= 0; --j) {
      min_x = min(min_x, point[j].xx);
      max_x = max(max_x, point[j].xx);
      max_y = max(max_y, point[j].yy);
      if ((max_x - min_x) * max_y > A) {
        break;
      }
      if (best[i + 1] > best[j] + 1) {
        best[i + 1] = best[j] + 1;
      }
    }
  }

  FILE *f = fopen("photo.out", "w");
  fprintf(f, "%d\n", best[N]);
  fclose(f);
}

int main() {
  read_data();
  solve_and_print();
  return 0;
}

