#include <stdio.h>
#include <string.h>
#include <assert.h>

#define NMAX 32
#define cmax(x) ((x) * ((x) + 1) / 2)
#define MOD 30011

int A[NMAX][cmax(NMAX)][cmax(NMAX)];
int D[NMAX][NMAX][NMAX * NMAX];
int S[cmax(NMAX) * 2];

void print_d() {
  int i, j, b;
  for (i = 0; i < NMAX - 1; i++) {
    for (j = 0; j < NMAX - 1; j++) {
      printf("%d,%d", i, j);
      for (b = 0; b <= i * j; b++) {
        printf("%3d ", D[i][j][b]);
      }
      printf("\n");
    }
  }
}

void print_a() {
  int n, i, j;
  for (n = 0; n < NMAX - 1; n++) {
    printf("N = %d\n", n);
    for (i = 0; i <= cmax(n); i++) {
      for (j = 0; j <= cmax(n); j++) {
        printf("%3d ", A[n][i][j]);
      }
      printf("\n");
    }
  }
}

void compute_d() {
  int i, j, b;

  D[0][0][0] = 1;
  for (i = 0; i < NMAX - 1; i++) {
    for (j = 0; j < NMAX - 1; j++) {
      for (b = 0; b <= i * j; b++) {
        D[i + 1][j][b + j] = (D[i+1][j][b +j] + D[i][j][b]) % MOD;
        D[i][j + 1][b] = (D[i][j + 1][b] + D[i][j][b]) % MOD;
      }
    }
  }

  //print_d();
}

void compute_a() {
  int n, k, q, b, bc, q1, b1, q2, b2;
  int l1, l2, sb;

  A[0][0][0] = A[1][0][0] = 1;

  for (n = 2; n < NMAX; n++) {
    fprintf(stderr, "%d\n", n);
    for (k = 1; k <= n; k++) {
      l1 = k - 1;
      l2 = n - k;
      for (q1 = 0; q1 <= cmax(l1); q1++) {
        for (q2 = 0; q2 <= cmax(l2); q2++) {
          memset(S, 0, sizeof(int) * (cmax(l1) + cmax(l2) + 1));
          for (b1 = 0; b1 <= cmax(l1); b1++) {
            for (b2 = 0; b2 <= cmax(l2); b2++) {
              S[b1 + b2] = (S[b1 + b2] + A[l1][q1][b1] * A[l2][q2][b2]) % MOD;
            }
          }

          q = q1 + q2 + n - 1;
          for (sb = 0; sb <= cmax(l1) + cmax(l2); sb++) {
            for (bc = 0; bc <= l1 * l2; bc++) {
              b = sb + bc + k - 1;
              A[n][q][b] = (A[n][q][b] + S[sb] * D[l1][l2][bc]) % MOD;
            }
          }
        }
      }
    }
  }

  //print_a();
}

int main() {
  int n, i, j, s, fact = 1;

  compute_d();
  compute_a();

  for (n = 1; n < NMAX; n++) {
    fact = (fact * n) % MOD;
    s = 0;
    for (i = 0; i <= cmax(n); i++) {
      for (j = 0; j <= cmax(n); j++) {
        printf("%6d", A[n][i][j]);
        s = (s + A[n][i][j]) % MOD;
      }
      printf("\n");
    }
    assert(fact == s);
  }

  return 0;
}
